#pragma once

#include "Config.h"
#include "IDrawable.h"
#include "Commands/ISelectCommand.h"

class Button: public IDrawable {
public:
    void set(const sf::Vector2f& pos, const sf::Vector2f& button_size, const std::string& text,
             size_t font_size, std::unique_ptr<ISelectCommand> ptr_command);
    void select() noexcept;
    void unselect() noexcept;
    bool is_selected() noexcept;
    bool is_position_in(sf::Vector2f pos) const noexcept;
    void push() const;
    void draw_into(sf::RenderWindow& window) const override;
public:
    Button();
private:
    sf::Text m_text;
    bool m_is_selected = false;
    sf::RectangleShape m_rectangle;
    std::unique_ptr<ISelectCommand> m_ptr_command;
};