#pragma once

#include <memory>

struct IStateManager;

class IState {
public:
    virtual bool do_step() = 0;
    virtual ~IState() = default;
public:
    IState(IStateManager& state_manager): m_state_manager(state_manager)  {}
protected:
    IStateManager& m_state_manager;
};

struct IStateManager {
    virtual void set_next_state(std::unique_ptr<IState>&& state) = 0;
    virtual ~IStateManager() = default;
};