#include "MazeContent/Buildings/Wall.h"
#include "Config.h"

void Wall::prepare_for_drawing()  {
    sf::Vector2f pos = m_room.get_position();

    switch (m_room.get_direction(this)) {
        case Room::LEFT:
            m_line[0] = sf::Vertex{sf::Vector2f(pos.x - m_room.get_size() / 2,
                                                pos.y - m_room.get_size() / 2), config::GAME_COLOR_WALL};
            m_line[1] = sf::Vertex{sf::Vector2f(pos.x - m_room.get_size() / 2,
                                                pos.y + m_room.get_size() / 2), config::GAME_COLOR_WALL};
            break;

        case Room::RIGHT:
            m_line[0] = sf::Vertex{ sf::Vector2f(pos.x + m_room.get_size() / 2,
                                                 pos.y - m_room.get_size() / 2), config::GAME_COLOR_WALL };
            m_line[1] = sf::Vertex{ sf::Vector2f(pos.x + m_room.get_size() / 2,
                                                 pos.y + m_room.get_size() / 2), config::GAME_COLOR_WALL };
            break;

        case Room::UP:
            m_line[0] = sf::Vertex{ sf::Vector2f( pos.x - m_room.get_size() / 2,
                                                  pos.y - m_room.get_size() / 2 ), config::GAME_COLOR_WALL };
            m_line[1] = sf::Vertex{ sf::Vector2f( pos.x + m_room.get_size() / 2,
                                                  pos.y - m_room.get_size() / 2), config::GAME_COLOR_WALL };
            break;

        case Room::DOWN:
            m_line[0] = sf::Vertex{ sf::Vector2f(pos.x - m_room.get_size() / 2,
                                                 pos.y + m_room.get_size() / 2), config::GAME_COLOR_WALL };
            m_line[1] = sf::Vertex{ sf::Vector2f(pos.x + m_room.get_size() / 2,
                                                 pos.y + m_room.get_size() / 2), config::GAME_COLOR_WALL };
            break;

        default:
            throw std::runtime_error("Invvalid side in the room!");
    }
}

void Wall::draw_into(sf::RenderWindow& window) const {
    window.draw(m_line, 2, sf::Lines);
};